/**
 * Just for fun, this was included to show just how fast certain recursive functions can grow
 */
import java.util.*;
public class Calc_Fun {
	public static void main(String[] args){
		Scanner in = new Scanner(System.in);
		long X, Y;
		
		System.out.print("Enter the first positive integer: ");
		X = in.nextLong();
		System.out.print("\nEnter the second positive integer: ");
		Y = in.nextLong();
		
		System.out.println("The Ackermann value, if one can be computed is (error = -1): " + 
				Ackermann(X,Y));
		
		//This just lets you go again. It is actually an example of using recursion!
		System.out.println("Would you like to go again?(1 = Yes): ");
		//You can re-use variable when you're done with them. It doesn't hurt anything
		X = in.nextLong();
		if (X == 1){
			main(null);
		}
	}
	
	/**
	 * This function grows rapidly. You will certainly invoke an exception for values 
	 *  with m = 4 or higher. (4,2) yields a number with over 10,000 digits!!! 
	 *  Your instructor has the option to make you compute this value ;( Ha Ha
	 */
	public static long Ackermann(long m, long n){
		if (m == 0){
			return (n+1);
		}else if (m > 0 && n == 0){
			return (Ackermann(m-1, 1));
		}else if (m > 0 && n > 0){
			return (Ackermann(m-1, Ackermann(m, n-1)));
		}else {
			return -1;
		}
	}
}
