/**
 * An example of a recurrence relation
 * What does this look like? It's a second-order linear homogeneous 
 *  recurrence relation with constant coefficients (both are 1). This indeed 
 *  means you can find an explicit formula
 *  
 *  As a programming exercise, see if you can implement a more efficient recursion using
 *   variables to store the previous values instead of function calls Fibonacci(k-1) + ...(k-2)
 */
public class Calc_Seq {
	
	public static void main(String[] args){
		for (int k = 1; k <= 20; k++){
			System.out.print(Fibonacci(k)+ ", ");
		}
	}
	
	private static int Fibonacci(int k) {
		 
		// Base Case:
		//   If k <= 2 then Fib(k) = 1.
		if (k <= 2) {
		    return 1;
		}
		// Recursive Case:
		//   If k > 2 then Fib(k) = Fib(k-1) + Fib(k-2).
		else {
		    return Fibonacci(k-1) + Fibonacci(k-2);
		} 
	}
}
