/**
 * Use the Explicit Formula for annually compounded interest 
 * 	to solve for the time in years to reach a particular balance
 */
import java.text.NumberFormat;
import java.util.Scanner;
public class Find_Time {

	public static void Calculate(){
		//Java-specific formatting and IO
		NumberFormat Time = NumberFormat.getInstance();
		Scanner in = new Scanner(System.in);
		
		//The time in years and the rate in percentages
		Double t, r;
		//The final and initial balances, respectively
		Double An, A0;
		
		//Obtain necessary information from the user. Assume numeric data
		System.out.println("What is the principle balance (the starting balance)?");
		A0 = in.nextDouble();
		System.out.println("What is the desired balance?");
		An = in.nextDouble();
		System.out.println("What is the interest rate (in percentages)?");
		r = in.nextDouble();
		
		//Manipulate the Explicit Formula to solve for t
		t = Math.log(An/A0)/Math.log(1+r/100.0);
		
		System.out.println("The time it takes to reach the desired balance is: " + 
				Time.format(t) + " years.");
		
		Compound_Interest.Restart();
	}
}