/**
 * Use the Recursive formula for interest compounded annually
 */
import java.util.*;
import java.text.NumberFormat;
public class Recursive_Annual {
	
	/**
	 * Pre: none
	 * Post: Assuming proper input, the ending balance of 
	 *  an account will be calculated and displayed
	 */
	public static void Calculate(){
		//Java-specific formatting and IO 
		NumberFormat currency = NumberFormat.getCurrencyInstance();
		Scanner in = new Scanner(System.in);
		
		//A one-dimensional array for holding the values for each successive year
		Double[] A;
		//Time in whole years
		int t;
		//Initial balance and the rate (in percentages)
		Double principal, r;
		
		//Obtain needed data from the user. Assume numeric input
		System.out.println("What is the initial balance in your account?");
		principal = in.nextDouble();
		System.out.println("What is the interest rate (in percentages)?");
		r = in.nextDouble();
		System.out.println("For how many whole years will interest be compounded?");
		t = in.nextInt();
	
		//Use number of years to size array, making sure to add an extra element for the principal
		A = new Double[t+1];
		//The first value in the array (year 0) is the principal
		A[0]=principal;
		
	
		//Beginning with year one, iterate the compound interest formula one year at a time
		for(int i=1; i <= t; i++){
			A[i] = (1+r/100.0)*A[i-1];
		}
		
		//Display and format the final account data
		System.out.println("The final balance of the account is: " + currency.format(A[t]));
		
		Compound_Interest.Restart();
	}

}
